/* 
   Copyright 1994-2003 Free Software Foundation, Inc.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 
   USA

   You may contact the author at:

   mailto::camille@bluegrass.net

   or by snail mail at:

   David Lindauer
   850 Washburn Ave Apt 99
   Louisville, KY 40222
*/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <errno.h>
#include <process.h>
#include <libp.h>
#include <dpmi.h>

struct sb {
	short envseg;
	short ocomtail;
	short scomtail;
	short ofcb1,sfcb1;
	short ofcb2,sfcb2;
};
extern UWORD _dtaseg;
extern SELECTOR _dtasel;

extern char **_environ ;

static char *fcbstring = "                ";

static char *createenviron(char **env, int *elen)
{
   int len = 0 ;
   char **dummy,*rv=0 ;
   if (!env)
      env = _environ ;
   dummy = env ;
   while (*dummy) {
      len += strlen(*dummy) + 1 ;
      dummy++ ;
   }
   if (len) {
      len += 1 ;
      rv = malloc (len) ;
      if (rv) {
         char *p = rv ;
         while(*env) {
            strcpy(p,*env) ;
            p+= strlen(p)+ 1 ;
            env++ ;
         }
         *p = 0 ;
      }
   }
   *elen = len ;
   return rv ;
}
int _ll_spawn(char *file, char *parms, char **env, int mode)
{
	DPMI_REGS regs;
	struct sb spawnblock;
	UWORD envseg;
	SELECTOR envsel;
	char parms1[256];
   int elen ;
   char *block = createenviron(env, &elen) ;
   if (!block)
      return -1 ;

   if (dpmi_alloc_real_memory(&envsel,&envseg,(elen+15)/16)*16) {
      free(block) ;
      return -1 ;
   }
   dpmi_copy_from_ds(envsel,0,block,elen) ;

	strcpy(parms1+1,parms);
	parms1[0] = strlen(parms);
	regs.h.dx = __nametodta(file,256);
	spawnblock.ocomtail =  __nametodta(parms1,512);
   spawnblock.scomtail =  _dtaseg;
	spawnblock.ofcb1 = __nametodta(fcbstring,768);
	spawnblock.ofcb2 = __nametodta(fcbstring,768+32);
   spawnblock.sfcb1 = spawnblock.sfcb2 = _dtaseg;
	spawnblock.envseg = envseg;
	regs.h.bx = __buftodta(&spawnblock,sizeof(struct sb));
	regs.b.al = 0;
	__doscall(0x4b,&regs);

   free(block) ;
   dpmi_dealloc_real_memory(envsel) ;

	if (regs.h.flags & 1)
		return -1;

	__doscall(0x4d,&regs);
	return regs.b.al;
}
int system(const char *string)
{
	FILE *f;
	char buf[100],*a;
	a = getenv("COMSPEC");
	if (!string) {
		if (!a)
			return 0;
		else
			if (f = fopen(a,"r")) {
				fclose(f);
				return 1;
			}
			else
				return 0;
	}
	if (!a) {
		errno = ENOENT;
		return -1;
	}
	buf[0] = ' ';
	buf[1] = '-';
	buf[2] = 'C';
	strcpy(buf+3,string);
	spawnlp(P_WAIT,a,a,buf,0);
	return 0;
}